/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { ComboDir_$type } from "./ComboDir";
import { GroupingDirection_$type } from "./GroupingDirection";
import { FilteringOptions } from "./FilteringOptions";
import { ComboChangeEventArgs } from "./ComboChangeEventArgs";
import { VoidEventArgs } from "./VoidEventArgs";
/**
 * @hidden
 */
export let Combo = /*@__PURE__*/ (() => {
    class Combo extends BaseElement {
        constructor() {
            super(...arguments);
            this.n = new WCNativeHelper();
            this.z = null;
            this.change = null;
            this.focus = null;
            this.blur = null;
            this.opening = null;
            this.opened = null;
            this.closing = null;
            this.closed = null;
            this.ac = null;
            this.ab = null;
        }
        get o() {
            return this.n;
        }
        get nativeElement() {
            return this.z;
        }
        set nativeElement(a) {
            this.z = a;
            this.n.o = this.z;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get a() {
            let ret_ = this.o.n("data");
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.o.v("data", value_);
        }
        get ag() {
            let ret_ = this.o.n("name");
            return ret_;
        }
        set ag(a) {
            let value_ = a;
            this.o.v("name", value_);
        }
        get s() {
            let ret_ = this.o.n("disabled");
            return ret_;
        }
        set s(a) {
            let value_ = a;
            this.o.v("disabled", value_);
        }
        get x() {
            let ret_ = this.o.n("required");
            return ret_;
        }
        set x(a) {
            let value_ = a;
            this.o.v("required", value_);
        }
        get u() {
            let ret_ = this.o.n("invalid");
            return ret_;
        }
        set u(a) {
            let value_ = a;
            this.o.v("invalid", value_);
        }
        get w() {
            let ret_ = this.o.n("outlined");
            return ret_;
        }
        set w(a) {
            let value_ = a;
            this.o.v("outlined", value_);
        }
        get y() {
            let ret_ = this.o.n("singleSelect");
            return ret_;
        }
        set y(a) {
            let value_ = a;
            this.o.v("singleSelect", value_);
        }
        get p() {
            let ret_ = this.o.n("autofocus");
            return ret_;
        }
        set p(a) {
            let value_ = a;
            this.o.v("autofocus", value_);
        }
        get q() {
            let ret_ = this.o.n("autofocusList");
            return ret_;
        }
        set q(a) {
            let value_ = a;
            this.o.v("autofocusList", value_);
        }
        get af() {
            let ret_ = this.o.n("label");
            return ret_;
        }
        set af(a) {
            let value_ = a;
            this.o.v("label", value_);
        }
        get ah() {
            let ret_ = this.o.n("placeholder");
            return ret_;
        }
        set ah(a) {
            let value_ = a;
            this.o.v("placeholder", value_);
        }
        get ai() {
            let ret_ = this.o.n("placeholderSearch");
            return ret_;
        }
        set ai(a) {
            let value_ = a;
            this.o.v("placeholderSearch", value_);
        }
        get e() {
            let ret_ = this.o.n("dir");
            ret_ = enumGetBox(ComboDir_$type, EnumUtil.getEnumValue(ComboDir_$type, this.o.f(ComboDir_$type, ret_)));
            return EnumUtil.getEnumValue(ComboDir_$type, ret_);
        }
        set e(a) {
            let value_ = enumGetBox(ComboDir_$type, a);
            value_ = WCNativeHelper.p(value_.toString());
            this.o.v("dir", value_);
        }
        get v() {
            let ret_ = this.o.n("open");
            return ret_;
        }
        set v(a) {
            let value_ = a;
            this.o.v("open", value_);
        }
        get aj() {
            let ret_ = this.o.n("valueKey");
            return ret_;
        }
        set aj(a) {
            let value_ = a;
            this.o.v("valueKey", value_);
        }
        get ad() {
            let ret_ = this.o.n("displayKey");
            return ret_;
        }
        set ad(a) {
            let value_ = a;
            this.o.v("displayKey", value_);
        }
        get ae() {
            let ret_ = this.o.n("groupKey");
            return ret_;
        }
        set ae(a) {
            let value_ = a;
            this.o.v("groupKey", value_);
        }
        get g() {
            let ret_ = this.o.n("groupSorting");
            ret_ = enumGetBox(GroupingDirection_$type, EnumUtil.getEnumValue(GroupingDirection_$type, this.o.f(GroupingDirection_$type, ret_)));
            return EnumUtil.getEnumValue(GroupingDirection_$type, ret_);
        }
        set g(a) {
            let value_ = enumGetBox(GroupingDirection_$type, a);
            value_ = WCNativeHelper.p(value_.toString());
            this.o.v("groupSorting", value_);
        }
        get f() {
            let ret_ = this.o.m("filteringOptions", (a) => new FilteringOptions());
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.o.v("filteringOptions", value_);
        }
        get r() {
            let ret_ = this.o.n("caseSensitiveIcon");
            return ret_;
        }
        set r(a) {
            let value_ = a;
            this.o.v("caseSensitiveIcon", value_);
        }
        get t() {
            let ret_ = this.o.n("disableFiltering");
            return ret_;
        }
        set t(a) {
            let value_ = a;
            this.o.v("disableFiltering", value_);
        }
        get c() {
            let ret_ = this.o.n("value");
            return ret_;
        }
        set c(a) {
            let value_ = a;
            this.o.v("value", value_);
        }
        get b() {
            let ret_ = this.o.n("selection");
            return ret_;
        }
        changeChanged() {
            if (this.change != null) {
                this.o.r("change", (a) => this.change(this, ComboChangeEventArgs.a(a)));
            }
            else {
                this.o.u("change");
            }
        }
        focusChanged() {
            if (this.focus != null) {
                this.o.r("focus", (a) => this.focus(this, VoidEventArgs.b(a)));
            }
            else {
                this.o.u("focus");
            }
        }
        blurChanged() {
            if (this.blur != null) {
                this.o.r("blur", (a) => this.blur(this, VoidEventArgs.b(a)));
            }
            else {
                this.o.u("blur");
            }
        }
        openingChanged() {
            if (this.opening != null) {
                this.o.r("opening", (a) => this.opening(this, VoidEventArgs.b(a)));
            }
            else {
                this.o.u("opening");
            }
        }
        openedChanged() {
            if (this.opened != null) {
                this.o.r("opened", (a) => this.opened(this, VoidEventArgs.b(a)));
            }
            else {
                this.o.u("opened");
            }
        }
        closingChanged() {
            if (this.closing != null) {
                this.o.r("closing", (a) => this.closing(this, VoidEventArgs.b(a)));
            }
            else {
                this.o.u("closing");
            }
        }
        closedChanged() {
            if (this.closed != null) {
                this.o.r("closed", (a) => this.closed(this, VoidEventArgs.b(a)));
            }
            else {
                this.o.u("closed");
            }
        }
        aw() {
            this.nativeElement.reportValidity();
        }
        an() {
            this.nativeElement.checkValidity();
        }
        as(a) {
            this.nativeElement.focus(this.o.i(a));
        }
        al() {
            this.nativeElement.blur();
        }
        ax(a) {
            this.nativeElement.select(this.o.i(a));
        }
        aq(a) {
            this.nativeElement.deselect(this.o.i(a));
        }
        az() {
            this.nativeElement.show();
        }
        at() {
            this.nativeElement.hide();
        }
        a0() {
            this.nativeElement.toggle();
        }
    }
    Combo.$t = /*@__PURE__*/ markType(Combo, 'Combo', BaseElement.$);
    return Combo;
})();
