import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { DropdownItem as DropdownItem_internal } from './DropdownItem';
import { IgrDropdownItem as IgrDropdownItem } from './igr-dropdown-item';
export class IgrDropdownItemCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrDropdownItem.$type) {
            IgrDropdownItem.$type = markType(IgrDropdownItem, "IgrDropdownItem");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrDropdownItem.$type) {
            IgrDropdownItem.$type = markType(IgrDropdownItem, "IgrDropdownItem");
        }
        let coll = new SyncableObservableCollection$2(IgrDropdownItem.$type, DropdownItem_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgrDropdownItem._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
