/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { ComboDir_$type } from "./ComboDir";
import { GroupingDirection_$type } from "./GroupingDirection";
import { FilteringOptions } from "./FilteringOptions";
import { ComboChangeEventArgs } from "./ComboChangeEventArgs";
import { VoidEventArgs } from "./VoidEventArgs";
/**
 * @hidden
 */
var Combo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Combo, _super);
    function Combo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.n = new WCNativeHelper();
        _this.z = null;
        _this.change = null;
        _this.focus = null;
        _this.blur = null;
        _this.opening = null;
        _this.opened = null;
        _this.closing = null;
        _this.closed = null;
        _this.ac = null;
        _this.ab = null;
        return _this;
    }
    Object.defineProperty(Combo.prototype, "o", {
        get: function () {
            return this.n;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "nativeElement", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            this.z = a;
            this.n.o = this.z;
        },
        enumerable: false,
        configurable: true
    });
    Combo.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(Combo.prototype, "a", {
        get: function () {
            var ret_ = this.o.n("data");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("data", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "ag", {
        get: function () {
            var ret_ = this.o.n("name");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("name", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "s", {
        get: function () {
            var ret_ = this.o.n("disabled");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("disabled", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "x", {
        get: function () {
            var ret_ = this.o.n("required");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("required", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "u", {
        get: function () {
            var ret_ = this.o.n("invalid");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("invalid", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "w", {
        get: function () {
            var ret_ = this.o.n("outlined");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("outlined", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "y", {
        get: function () {
            var ret_ = this.o.n("singleSelect");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("singleSelect", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "p", {
        get: function () {
            var ret_ = this.o.n("autofocus");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("autofocus", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "q", {
        get: function () {
            var ret_ = this.o.n("autofocusList");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("autofocusList", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "af", {
        get: function () {
            var ret_ = this.o.n("label");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("label", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "ah", {
        get: function () {
            var ret_ = this.o.n("placeholder");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("placeholder", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "ai", {
        get: function () {
            var ret_ = this.o.n("placeholderSearch");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("placeholderSearch", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "e", {
        get: function () {
            var ret_ = this.o.n("dir");
            ret_ = enumGetBox(ComboDir_$type, EnumUtil.getEnumValue(ComboDir_$type, this.o.f(ComboDir_$type, ret_)));
            return EnumUtil.getEnumValue(ComboDir_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(ComboDir_$type, a);
            value_ = WCNativeHelper.p(value_.toString());
            this.o.v("dir", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "v", {
        get: function () {
            var ret_ = this.o.n("open");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("open", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "aj", {
        get: function () {
            var ret_ = this.o.n("valueKey");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("valueKey", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "ad", {
        get: function () {
            var ret_ = this.o.n("displayKey");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("displayKey", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "ae", {
        get: function () {
            var ret_ = this.o.n("groupKey");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("groupKey", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "g", {
        get: function () {
            var ret_ = this.o.n("groupSorting");
            ret_ = enumGetBox(GroupingDirection_$type, EnumUtil.getEnumValue(GroupingDirection_$type, this.o.f(GroupingDirection_$type, ret_)));
            return EnumUtil.getEnumValue(GroupingDirection_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(GroupingDirection_$type, a);
            value_ = WCNativeHelper.p(value_.toString());
            this.o.v("groupSorting", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "f", {
        get: function () {
            var ret_ = this.o.m("filteringOptions", function (a) { return new FilteringOptions(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("filteringOptions", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "r", {
        get: function () {
            var ret_ = this.o.n("caseSensitiveIcon");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("caseSensitiveIcon", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "t", {
        get: function () {
            var ret_ = this.o.n("disableFiltering");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("disableFiltering", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "c", {
        get: function () {
            var ret_ = this.o.n("value");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.o.v("value", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Combo.prototype, "b", {
        get: function () {
            var ret_ = this.o.n("selection");
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Combo.prototype.changeChanged = function () {
        var _this = this;
        if (this.change != null) {
            this.o.r("change", function (a) { return _this.change(_this, ComboChangeEventArgs.a(a)); });
        }
        else {
            this.o.u("change");
        }
    };
    Combo.prototype.focusChanged = function () {
        var _this = this;
        if (this.focus != null) {
            this.o.r("focus", function (a) { return _this.focus(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.o.u("focus");
        }
    };
    Combo.prototype.blurChanged = function () {
        var _this = this;
        if (this.blur != null) {
            this.o.r("blur", function (a) { return _this.blur(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.o.u("blur");
        }
    };
    Combo.prototype.openingChanged = function () {
        var _this = this;
        if (this.opening != null) {
            this.o.r("opening", function (a) { return _this.opening(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.o.u("opening");
        }
    };
    Combo.prototype.openedChanged = function () {
        var _this = this;
        if (this.opened != null) {
            this.o.r("opened", function (a) { return _this.opened(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.o.u("opened");
        }
    };
    Combo.prototype.closingChanged = function () {
        var _this = this;
        if (this.closing != null) {
            this.o.r("closing", function (a) { return _this.closing(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.o.u("closing");
        }
    };
    Combo.prototype.closedChanged = function () {
        var _this = this;
        if (this.closed != null) {
            this.o.r("closed", function (a) { return _this.closed(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.o.u("closed");
        }
    };
    Combo.prototype.aw = function () {
        this.nativeElement.reportValidity();
    };
    Combo.prototype.an = function () {
        this.nativeElement.checkValidity();
    };
    Combo.prototype.as = function (a) {
        this.nativeElement.focus(this.o.i(a));
    };
    Combo.prototype.al = function () {
        this.nativeElement.blur();
    };
    Combo.prototype.ax = function (a) {
        this.nativeElement.select(this.o.i(a));
    };
    Combo.prototype.aq = function (a) {
        this.nativeElement.deselect(this.o.i(a));
    };
    Combo.prototype.az = function () {
        this.nativeElement.show();
    };
    Combo.prototype.at = function () {
        this.nativeElement.hide();
    };
    Combo.prototype.a0 = function () {
        this.nativeElement.toggle();
    };
    Combo.$t = markType(Combo, 'Combo', BaseElement.$);
    return Combo;
}(BaseElement));
export { Combo };
