/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Dropdown } from "./Dropdown";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { SelectDir_$type } from "./SelectDir";
import { VoidEventArgs } from "./VoidEventArgs";
/**
 * @hidden
 */
var Select = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Select, _super);
    function Select() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.focus = null;
        _this.blur = null;
        return _this;
    }
    Object.defineProperty(Select.prototype, "ak", {
        get: function () {
            var ret_ = this.i.n("value");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("value", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ai", {
        get: function () {
            var ret_ = this.i.n("name");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("name", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ad", {
        get: function () {
            var ret_ = this.i.n("disabled");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("disabled", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ag", {
        get: function () {
            var ret_ = this.i.n("required");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("required", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ae", {
        get: function () {
            var ret_ = this.i.n("invalid");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("invalid", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "af", {
        get: function () {
            var ret_ = this.i.n("outlined");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("outlined", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ac", {
        get: function () {
            var ret_ = this.i.n("autofocus");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("autofocus", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ah", {
        get: function () {
            var ret_ = this.i.n("label");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("label", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "aj", {
        get: function () {
            var ret_ = this.i.n("placeholder");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.v("placeholder", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "z", {
        get: function () {
            var ret_ = this.i.n("dir");
            ret_ = enumGetBox(SelectDir_$type, EnumUtil.getEnumValue(SelectDir_$type, this.i.f(SelectDir_$type, ret_)));
            return EnumUtil.getEnumValue(SelectDir_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(SelectDir_$type, a);
            value_ = WCNativeHelper.p(value_.toString());
            this.i.v("dir", value_);
        },
        enumerable: false,
        configurable: true
    });
    Select.prototype.focusChanged = function () {
        var _this = this;
        if (this.focus != null) {
            this.i.r("focus", function (a) { return _this.focus(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.i.u("focus");
        }
    };
    Select.prototype.blurChanged = function () {
        var _this = this;
        if (this.blur != null) {
            this.i.r("blur", function (a) { return _this.blur(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.i.u("blur");
        }
    };
    Select.prototype.ap = function (a) {
        this.nativeElement.focus(this.i.i(a));
    };
    Select.prototype.am = function () {
        this.nativeElement.blur();
    };
    Select.prototype.aq = function () {
        this.nativeElement.reportValidity();
    };
    Select.prototype.an = function () {
        this.nativeElement.checkValidity();
    };
    Select.$t = markType(Select, 'Select', Dropdown.$);
    return Select;
}(Dropdown));
export { Select };
