/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { StepStepType_$type } from "./StepStepType";
import { StepTitlePosition_$type } from "./StepTitlePosition";
import { StepOrientation_$type } from "./StepOrientation";
/**
 * @hidden
 */
var Step = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Step, _super);
    function Step() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = new WCNativeHelper();
        _this.p = null;
        return _this;
    }
    Object.defineProperty(Step.prototype, "e", {
        get: function () {
            return this.d;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Step.prototype, "nativeElement", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            this.p = a;
            this.d.o = this.p;
        },
        enumerable: false,
        configurable: true
    });
    Step.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(Step.prototype, "j", {
        get: function () {
            var ret_ = this.e.n("invalid");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("invalid", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Step.prototype, "f", {
        get: function () {
            var ret_ = this.e.n("active");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("active", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Step.prototype, "l", {
        get: function () {
            var ret_ = this.e.n("optional");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("optional", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Step.prototype, "i", {
        get: function () {
            var ret_ = this.e.n("disabled");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("disabled", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Step.prototype, "g", {
        get: function () {
            var ret_ = this.e.n("complete");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("complete", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Step.prototype, "m", {
        get: function () {
            var ret_ = this.e.n("previousComplete");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("previousComplete", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Step.prototype, "b", {
        get: function () {
            var ret_ = this.e.n("stepType");
            ret_ = enumGetBox(StepStepType_$type, EnumUtil.getEnumValue(StepStepType_$type, this.e.f(StepStepType_$type, ret_)));
            return EnumUtil.getEnumValue(StepStepType_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(StepStepType_$type, a);
            value_ = WCNativeHelper.p(value_.toString());
            this.e.v("stepType", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Step.prototype, "c", {
        get: function () {
            var ret_ = this.e.n("titlePosition");
            ret_ = enumGetBox(StepTitlePosition_$type, EnumUtil.getEnumValue(StepTitlePosition_$type, this.e.f(StepTitlePosition_$type, ret_)));
            return EnumUtil.getEnumValue(StepTitlePosition_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(StepTitlePosition_$type, a);
            value_ = WCNativeHelper.p(value_.toString());
            this.e.v("titlePosition", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Step.prototype, "a", {
        get: function () {
            var ret_ = this.e.n("orientation");
            ret_ = enumGetBox(StepOrientation_$type, EnumUtil.getEnumValue(StepOrientation_$type, this.e.f(StepOrientation_$type, ret_)));
            return EnumUtil.getEnumValue(StepOrientation_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(StepOrientation_$type, a);
            value_ = WCNativeHelper.p(value_.toString());
            this.e.v("orientation", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Step.prototype, "o", {
        get: function () {
            var ret_ = this.e.n("index");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("index", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Step.prototype, "h", {
        get: function () {
            var ret_ = this.e.n("contentTop");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("contentTop", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Step.prototype, "k", {
        get: function () {
            var ret_ = this.e.n("linearDisabled");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("linearDisabled", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Step.prototype, "n", {
        get: function () {
            var ret_ = this.e.n("visited");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.e.v("visited", value_);
        },
        enumerable: false,
        configurable: true
    });
    Step.$t = markType(Step, 'Step', BaseElement.$);
    return Step;
}(BaseElement));
export { Step };
