import { ComboTemplateProps as ComboTemplateProps_internal } from "./ComboTemplateProps";
var IgrComboTemplateProps = /** @class */ /*@__PURE__*/ (function () {
    function IgrComboTemplateProps() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrComboTemplateProps.prototype.createImplementation = function () {
        return new ComboTemplateProps_internal();
    };
    Object.defineProperty(IgrComboTemplateProps.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrComboTemplateProps.prototype.onImplementationCreated = function () {
    };
    IgrComboTemplateProps.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgrComboTemplateProps.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrComboTemplateProps;
}());
export { IgrComboTemplateProps };
