import { FilteringOptions as FilteringOptions_internal } from "./FilteringOptions";
var IgrFilteringOptions = /** @class */ /*@__PURE__*/ (function () {
    function IgrFilteringOptions() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrFilteringOptions.prototype.createImplementation = function () {
        return new FilteringOptions_internal();
    };
    Object.defineProperty(IgrFilteringOptions.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrFilteringOptions.prototype.onImplementationCreated = function () {
    };
    IgrFilteringOptions.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgrFilteringOptions.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrFilteringOptions;
}());
export { IgrFilteringOptions };
