import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { Type } from "igniteui-react-core";
import { ComboDir } from "./ComboDir";
import { GroupingDirection } from "./GroupingDirection";
import { FilteringOptions } from "./FilteringOptions";
import { ComboChangeEventArgs } from "./ComboChangeEventArgs";
import { VoidEventArgs } from "./VoidEventArgs";
import { FocusOptions } from "./FocusOptions";
/**
 * @hidden
 */
export declare class Combo extends BaseElement {
    static $t: Type;
    private n;
    protected get o(): WCNativeHelper;
    private z;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get a(): any[];
    set a(a: any[]);
    get ag(): string;
    set ag(a: string);
    get s(): boolean;
    set s(a: boolean);
    get x(): boolean;
    set x(a: boolean);
    get u(): boolean;
    set u(a: boolean);
    get w(): boolean;
    set w(a: boolean);
    get y(): boolean;
    set y(a: boolean);
    get p(): boolean;
    set p(a: boolean);
    get q(): boolean;
    set q(a: boolean);
    get af(): string;
    set af(a: string);
    get ah(): string;
    set ah(a: string);
    get ai(): string;
    set ai(a: string);
    get e(): ComboDir;
    set e(a: ComboDir);
    get v(): boolean;
    set v(a: boolean);
    get aj(): string;
    set aj(a: string);
    get ad(): string;
    set ad(a: string);
    get ae(): string;
    set ae(a: string);
    get g(): GroupingDirection;
    set g(a: GroupingDirection);
    get f(): FilteringOptions;
    set f(a: FilteringOptions);
    get r(): boolean;
    set r(a: boolean);
    get t(): boolean;
    set t(a: boolean);
    get c(): any[];
    set c(a: any[]);
    get b(): any[];
    change: (sender: any, args: ComboChangeEventArgs) => void;
    changeChanged(): void;
    focus: (sender: any, args: VoidEventArgs) => void;
    focusChanged(): void;
    blur: (sender: any, args: VoidEventArgs) => void;
    blurChanged(): void;
    opening: (sender: any, args: VoidEventArgs) => void;
    openingChanged(): void;
    opened: (sender: any, args: VoidEventArgs) => void;
    openedChanged(): void;
    closing: (sender: any, args: VoidEventArgs) => void;
    closingChanged(): void;
    closed: (sender: any, args: VoidEventArgs) => void;
    closedChanged(): void;
    aw(): void;
    an(): void;
    as(a: FocusOptions): void;
    al(): void;
    ax(a: any[]): void;
    aq(a: any[]): void;
    az(): void;
    at(): void;
    a0(): void;
    ac: (arg: any) => any;
    ab: (arg: any) => any;
}
