import { MaskInputBase } from "./MaskInputBase";
import { Type } from "igniteui-react-core";
import { DatePartDeltas } from "./DatePartDeltas";
import { ComponentDateValueChangedEventArgs } from "./ComponentDateValueChangedEventArgs";
import { DatePart } from "./DatePart";
/**
 * @hidden
 */
export declare class DateTimeInput extends MaskInputBase {
    static $t: Type;
    get al(): string;
    set al(a: string);
    get aj(): Date;
    set aj(a: Date);
    get ai(): Date;
    set ai(a: Date);
    get ah(): Date;
    set ah(a: Date);
    get ak(): string;
    set ak(a: string);
    get af(): DatePartDeltas;
    set af(a: DatePartDeltas);
    get ag(): boolean;
    set ag(a: boolean);
    get am(): string;
    set am(a: string);
    change: (sender: any, args: ComponentDateValueChangedEventArgs) => void;
    changeChanged(): void;
    aq(): void;
    ar(): void;
    ao(): void;
    at(a: DatePart, b: number): void;
    as(a: DatePart, b: number): void;
    ap(): void;
}
