import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { Type } from "igniteui-react-core";
import { DockManagerLayout } from "./DockManagerLayout";
import { DockManagerPane } from "./DockManagerPane";
import { DockManagerPoint } from "./DockManagerPoint";
import { ContentPane } from "./ContentPane";
import { DockManagerShowHeaderIconOnHover } from "./DockManagerShowHeaderIconOnHover";
import { DockManagerResourceStrings } from "./DockManagerResourceStrings";
import { LayoutChangeEventArgs } from "./LayoutChangeEventArgs";
/**
 * @hidden
 */
export declare class DockManager extends BaseElement {
    static $t: Type;
    layoutChange: (sender: any, args: LayoutChangeEventArgs) => void;
    layoutChangeChanged(): void;
    private i;
    protected get j(): WCNativeHelper;
    private o;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get b(): DockManagerLayout;
    set b(a: DockManagerLayout);
    get c(): DockManagerPane;
    set c(a: DockManagerPane);
    get e(): DockManagerPoint;
    set e(a: DockManagerPoint);
    get a(): ContentPane;
    set a(a: ContentPane);
    get m(): boolean;
    set m(a: boolean);
    get g(): DockManagerShowHeaderIconOnHover;
    set g(a: DockManagerShowHeaderIconOnHover);
    get d(): DockManagerPane;
    set d(a: DockManagerPane);
    get f(): DockManagerResourceStrings;
    set f(a: DockManagerResourceStrings);
    get k(): boolean;
    set k(a: boolean);
    get n(): boolean;
    set n(a: boolean);
    get l(): boolean;
    set l(a: boolean);
    q(a: string): void;
}
