import { IgrDockManagerPane } from "./igr-dock-manager-pane";
import { PaneCloseEventArgsDetail as PaneCloseEventArgsDetail_internal } from "./PaneCloseEventArgsDetail";
import { ContentChildrenManager } from "igniteui-react-core";
import { IgrContentPane } from "./igr-content-pane";
export declare class IgrPaneCloseEventArgsDetail {
    protected createImplementation(): PaneCloseEventArgsDetail_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): PaneCloseEventArgsDetail_internal;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Get the source pane that triggers the close.
    */
    get sourcePane(): IgrDockManagerPane;
    set sourcePane(v: IgrDockManagerPane);
    /**
     * Gets/sets the panes that are about to close.
    */
    get panes(): IgrContentPane[];
    set panes(v: IgrContentPane[]);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
