import * as React from 'react';
import { PaneDragAction } from "./PaneDragAction";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrPaneDragAction<P extends IIgrPaneDragActionProps = IIgrPaneDragActionProps> extends React.Component<P, {}> {
    protected createImplementation(): PaneDragAction;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): PaneDragAction; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrPaneDragAction;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): any;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
}
export interface IIgrPaneDragActionProps {
    children?: React.ReactNode;
}
