import { IgrDockManagerPane } from "./igr-dock-manager-pane";
import { PaneDragStartEventArgsDetail as PaneDragStartEventArgsDetail_internal } from "./PaneDragStartEventArgsDetail";
import { ContentChildrenManager } from "igniteui-react-core";
import { IgrContentPane } from "./igr-content-pane";
export declare class IgrPaneDragStartEventArgsDetail {
    protected createImplementation(): PaneDragStartEventArgsDetail_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): PaneDragStartEventArgsDetail_internal;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the source pane that triggers the drag start.
    */
    get sourcePane(): IgrDockManagerPane;
    set sourcePane(v: IgrDockManagerPane);
    /**
     * Gets the panes that are about to get dragged.
    */
    get panes(): IgrContentPane[];
    set panes(v: IgrContentPane[]);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
