import { ComponentValueChangedEventArgs as ComponentValueChangedEventArgs_internal } from "./ComponentValueChangedEventArgs";
export class IgrComponentValueChangedEventArgs {
    createImplementation() {
        return new ComponentValueChangedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get detail() {
        return this.i.b;
    }
    set detail(v) {
        this.i.b = v;
    }
}
