import { ComponentBoolValueChangedEventArgs as ComponentBoolValueChangedEventArgs_internal } from "./ComponentBoolValueChangedEventArgs";
import { ensureBool } from "igniteui-react-core";
var IgrComponentBoolValueChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrComponentBoolValueChangedEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrComponentBoolValueChangedEventArgs.prototype.createImplementation = function () {
        return new ComponentBoolValueChangedEventArgs_internal();
    };
    Object.defineProperty(IgrComponentBoolValueChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrComponentBoolValueChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrComponentBoolValueChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrComponentBoolValueChangedEventArgs.prototype, "detail", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrComponentBoolValueChangedEventArgs;
}());
export { IgrComponentBoolValueChangedEventArgs };
