import { DatePartDeltas as DatePartDeltas_internal } from "./DatePartDeltas";
var IgrDatePartDeltas = /** @class */ /*@__PURE__*/ (function () {
    function IgrDatePartDeltas() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrDatePartDeltas.prototype.createImplementation = function () {
        return new DatePartDeltas_internal();
    };
    Object.defineProperty(IgrDatePartDeltas.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrDatePartDeltas.prototype.onImplementationCreated = function () {
    };
    IgrDatePartDeltas.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrDatePartDeltas.prototype, "date", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDatePartDeltas.prototype, "month", {
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDatePartDeltas.prototype, "year", {
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDatePartDeltas.prototype, "hours", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDatePartDeltas.prototype, "minutes", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDatePartDeltas.prototype, "seconds", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = +v;
        },
        enumerable: false,
        configurable: true
    });
    IgrDatePartDeltas.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrDatePartDeltas;
}());
export { IgrDatePartDeltas };
