import { FocusOptions as FocusOptions_internal } from "./FocusOptions";
import { ensureBool } from "igniteui-react-core";
var IgrFocusOptions = /** @class */ /*@__PURE__*/ (function () {
    function IgrFocusOptions() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrFocusOptions.prototype.createImplementation = function () {
        return new FocusOptions_internal();
    };
    Object.defineProperty(IgrFocusOptions.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrFocusOptions.prototype.onImplementationCreated = function () {
    };
    IgrFocusOptions.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrFocusOptions.prototype, "preventScroll", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrFocusOptions.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrFocusOptions;
}());
export { IgrFocusOptions };
