import { IgrDockManagerLayout } from "./igr-dock-manager-layout";
import { LayoutChangeEventArgs as LayoutChangeEventArgs_internal } from "./LayoutChangeEventArgs";
var IgrLayoutChangeEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrLayoutChangeEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrLayoutChangeEventArgs.prototype.createImplementation = function () {
        return new LayoutChangeEventArgs_internal();
    };
    Object.defineProperty(IgrLayoutChangeEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrLayoutChangeEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrLayoutChangeEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrLayoutChangeEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrDockManagerLayout();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrLayoutChangeEventArgs;
}());
export { IgrLayoutChangeEventArgs };
