import { VoidEventArgs as VoidEventArgs_internal } from "./VoidEventArgs";
var IgrVoidEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrVoidEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrVoidEventArgs.prototype.createImplementation = function () {
        return new VoidEventArgs_internal();
    };
    Object.defineProperty(IgrVoidEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrVoidEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrVoidEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    return IgrVoidEventArgs;
}());
export { IgrVoidEventArgs };
