import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { Type } from "igniteui-react-core";
import { DropdownPlacement } from "./DropdownPlacement";
import { DropdownPositionStrategy } from "./DropdownPositionStrategy";
import { DropdownScrollStrategy } from "./DropdownScrollStrategy";
import { SizableComponentSize } from "./SizableComponentSize";
import { DropdownItem } from "./DropdownItem";
import { DropdownItemComponentEventArgs } from "./DropdownItemComponentEventArgs";
/**
 * @hidden
 */
export declare class Dropdown extends BaseElement {
    static $t: Type;
    v(): void;
    x(): void;
    showTarget(target_: any): void;
    toggleTarget(target_: any): void;
    a(a: any): DropdownItem;
    b(a: any): DropdownItem;
    private h;
    protected get i(): WCNativeHelper;
    private p;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get l(): boolean;
    set l(a: boolean);
    get m(): boolean;
    set m(a: boolean);
    get d(): DropdownPlacement;
    set d(a: DropdownPlacement);
    get e(): DropdownPositionStrategy;
    set e(a: DropdownPositionStrategy);
    get f(): DropdownScrollStrategy;
    set f(a: DropdownScrollStrategy);
    get j(): boolean;
    set j(a: boolean);
    get o(): number;
    set o(a: number);
    get k(): boolean;
    set k(a: boolean);
    get n(): boolean;
    set n(a: boolean);
    get g(): SizableComponentSize;
    set g(a: SizableComponentSize);
    change: (sender: any, args: DropdownItemComponentEventArgs) => void;
    changeChanged(): void;
    t(): void;
    s(): void;
}
