import { IgrContentPane } from "./igr-content-pane";
import { IgrTabHeaderElement } from "./igr-tab-header-element";
import { TabHeaderConnectionEventArgsDetail as TabHeaderConnectionEventArgsDetail_internal } from "./TabHeaderConnectionEventArgsDetail";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrTabHeaderConnectionEventArgsDetail {
    protected createImplementation(): TabHeaderConnectionEventArgsDetail_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): TabHeaderConnectionEventArgsDetail_internal;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The pane whose tab header is being connected/disconnected.
    */
    get pane(): IgrContentPane;
    set pane(v: IgrContentPane);
    /**
     * The tab header element that is being connected/disconnected.
    */
    get element(): IgrTabHeaderElement;
    set element(v: IgrTabHeaderElement);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
